Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Cached_Allocator Class Template Reference

Create a cached memory poll with <n_chunks> chunks each with sizeof (TYPE) size. More...

`#include <Malloc_T.h>`

Inheritance diagram for ACE_Cached_Allocator

[legend]
Collaboration diagram for ACE_Cached_Allocator:

[legend]
List of all members.

## Public Methods
| ACE_Cached_Allocator (size_t n_chunks)
| Create a cached memory poll with <n_chunks> chunks each with sizeof (TYPE) size.
| ~ACE_Cached_Allocator (void)
| clear things up.
void* | malloc (size_t nbytes = sizeof (T))
virtual void* | calloc (size_t nbytes, char initial_value = '\0')
virtual void* | calloc (size_t n_elem, size_t elem_size, char initial_value = '\0')
| This method is a no-op and just returns 0 since the free list only works with fixed sized entities.
void | free (void *)
| Return a chunk of memory back to free list cache.
## Private Attributes
char* | pool_
| Remember how we allocate the memory in the first place so we can clear things up later.
ACE_Locked_Free_List<ACE_Cached_Mem_Pool_Node< T>, ACE_LOCK> | free_list_
| Maintain a cached memory free list.

## Detailed Description

### template<class T, class ACE_LOCK> template class ACE_Cached_Allocator

Create a cached memory poll with <n_chunks> chunks each with sizeof (TYPE) size.

This class enables caching of dynamically allocated, fixed-sized classes. Notice that the `sizeof (TYPE)` must be greater than or equal to `sizeof (void*)` for this to work properly.

See also:
  ACE_Cached_Mem_Pool_Node

## Constructor & Destructor Documentation

template<classT, classACE_LOCK>
ACE_Cached_Allocator<T, ACE_LOCK>::ACE_Cached_Allocator<T, ACE_LOCK> ( | size_t n_chunks )`[inline]`

| Create a cached memory poll with <n_chunks> chunks each with sizeof (TYPE) size.

template<classT, classACE_LOCK>
ACE_Cached_Allocator<T, ACE_LOCK>::~ACE_Cached_Allocator<T, ACE_LOCK> ( | void )

| clear things up.

## Member Function Documentation

template<classT, classACE_LOCK>
ACE_INLINE void * ACE_Cached_Allocator< T,ACE_LOCK >::calloc ( | size_t n_elem,
| size_t elem_size,
| char initial_value = '\0' )`[virtual]`

| This method is a no-op and just returns 0 since the free list only works with fixed sized entities. Reimplemented from ACE_New_Allocator.

template<classT, classACE_LOCK>
ACE_INLINE void * ACE_Cached_Allocator< T,ACE_LOCK >::calloc ( | size_t nbytes,
| char initial_value = '\0' )`[virtual]`

| Get a chunk of memory from free list cache, giving them <initial_value>. Note that <nbytes> is only checked to make sure that it's <= to sizeof T, and is otherwise ignored since <malloc> always returns a pointer to an item of sizeof (T). Reimplemented from ACE_New_Allocator.

template<classT, classACE_LOCK>
ACE_INLINE void ACE_Cached_Allocator< T,ACE_LOCK >::free ( | void * ptr )`[virtual]`

| Return a chunk of memory back to free list cache. Reimplemented from ACE_New_Allocator.

template<classT, classACE_LOCK>
ACE_INLINE void * ACE_Cached_Allocator< T,ACE_LOCK >::malloc ( | size_t nbytes = sizeof (T) )`[virtual]`

| Get a chunk of memory from free list cache. Note that <nbytes> is only checked to make sure that it's <= to sizeof T, and is otherwise ignored since <malloc> always returns a pointer to an item of sizeof (T). Reimplemented from ACE_New_Allocator.

## Member Data Documentation

template<classT, classACE_LOCK>
ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< T >,ACE_LOCK > ACE_Cached_Allocator<T, ACE_LOCK>::free_list_`[private]`

| Maintain a cached memory free list.

template<classT, classACE_LOCK>
char * ACE_Cached_Allocator<T, ACE_LOCK>::pool_`[private]`

| Remember how we allocate the memory in the first place so we can clear things up later.

The documentation for this class was generated from the following files:

- Malloc_T.h
- Malloc_T.cpp
- Malloc_T.i